/*
 * Nombre del Proyecto:
     Proyecto2.c
 * Nombre del Autor:
     Nestor Naula Lpez
 * Description:
     Este proyecto deber poder ejecutar dos ejercicios:
1.        Ejercicio en lenguaje C propuesto por el profesor que consiste en la lectura de los valores analgicos de un potencimetro colocado en patita RE0/AN5 del PIC16F887, presentando las variaciones de valores en binario y su equivalente decimal en una pantalla LCD 4x20.
2.        Ejercicio en lenguaje C de un JUEGO PROPUESTO POR EL ESTUDIANTE haciendo uso de: teclado 4x4, pantalla LCD, display de 7 segmentos y LEDs.
     Funcionamiento:
a.        Al encenderse el circuito debern aparecer un men inicial en la pantalla LCD 4x20.
b.        Sus iniciales (de nombre y apellido) en displays de 7 segmentos.
c.        Al presionar una tecla 1 se inicia el ejercicio 1, el cual mide el valor del potenciomentro, moestrando en la pantalla lcd 4x16 su equivalente en binario y decimal
d.        Al presionar otra tecla 2 se inicia el ejercicio 2, el cual juega 21 el jugador vs la computadora, mostrandole si gano o no.
e.        Al presionar otra tecla 3 sale del ejercicio 1 y 2, cunado se esta dentro de cualquiera de ellos.
******************************************************
  * Test configuration:
     MCU:             PIC16F887
     Oscillator:      HS, 08.0000 MHz
     SW:              mikroC PRO for PIC

 * NOTES:

*/

unsigned short kp, cnt, opci, oldstate = 0,j,k,controlE=0;
char txt[6];
char txt2[1];
unsigned int temp_res,temp1,temp2,temp3,temp4,i,num1,num2,num3,puntos;
// Keypad module connections
char  keypadPort at PORTD;
// End Keypad module connections

// LCD module connections
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
// End LCD module connections

void main() {
    PORTB = 0xFF;
    PORTC = 0;
    TRISC = 0;
    cnt = 0;                                 // Reset counter
    ANSEL  = 0x32;              // Configure AN2 pin as analog
    ANSELH = 0;                 // Configure other AN pins as digital I/O
    C1ON_bit = 0;               // Disable comparators
    C2ON_bit = 0;

    TRISE  = 0x04;              // PORTE is input
    TRISA  = 0;                 // PORTA is output
    TRISB  = 0;                 // PORTB is output
    temp3=0;
  Keypad_Init();                           // Initialize Keypad
  Lcd_Init();                              // Initialize Lcd
  RB6_bit =0;
  opci = 0;
  do {
    RB6_bit =0;
    Lcd_Cmd(_LCD_CLEAR);                      // Clear display
    Lcd_Cmd(_LCD_CURSOR_OFF);                 // Cursor off
    Lcd_Out(1, 1, "Elija el juego  :");                 // Write message text on Lcd
    Lcd_Out(2, 1, "1) Potenciomentro");
    Lcd_Out(3, 1, "2) Juego 21");
    PORTC=0x48;
    PORTA=0x48;
      do  {
       opci = Keypad_Key_Click();             // Store key code in kp variable
       delay_ms(100)  ;
       }
    while (!opci);
   if(opci == 1)
     Lcd_Out(1, 18, " 1");
    if(opci == 2)
     Lcd_Out(1, 18, " 2");
    delay_ms(500)  ;
    if(opci==1)
    {
      Lcd_Cmd(_LCD_CLEAR);
      Lcd_Cmd(_LCD_CURSOR_OFF);
      do {
        PORTC=0x48;
        PORTA=0x48;
        temp_res = ADC_Read(5);   // Get 10-bit results of AD conversion
        temp1 = (temp_res)*(100)/(1024);
        temp4=temp1;
        if(temp3!=temp1){
        for (i=0; i<8;i++){
            temp3=temp1;
            temp2 = temp4 % 2;
            temp4= temp4/2;
            if (temp2<=1) {
              WordToStr(temp2, txt);
              Lcd_Out(2, 14-i, txt);
            }

        }
        }
        WordToStr(temp1, txt);                   // Transform counter value to string
        Lcd_Out(3, 10, txt);
        Lcd_Out(1, 2, "Juego Potenciometro");            // Write message text on Lcd
        Lcd_Out(2, 1, "Binario :");
        Lcd_Out(3, 1, "Decimal :");
        opci = Keypad_Key_Click();
        if(opci==3)
          break;
      } while(1);

    }
    if(opci==2 ){
    controlE=0;
    do{
        kp = 0;
        num2 =0;
        num3 =0;
        puntos=0;
        Lcd_Cmd(_LCD_CLEAR);                      // Clear display
        Lcd_Cmd(_LCD_CURSOR_OFF);
        Lcd_Out(1, 2, "Juego 21");            // Write message text on Lcd
        Lcd_Out(2, 1, "CartaBan:");            // Write message text on Lcd
        Lcd_Out(3, 1, "CartaJug:");            // Write message text on Lcd
        PORTC=0x01;
        PORTA=0x01;
        RC7_bit =0;
     do{
        PORTC=0x48;
        PORTA=0x48;
        do{
         while(!RE2_bit){
            puntos=0;
            j=(rand()%10)+1 ;
            opci = Keypad_Key_Click();
            delay_ms(100)  ;
            if(opci==3)
             controlE=1;
         };
          k=(rand()%10)+1;
          delay_ms(100)  ;
          puntos= 1;
          if(controlE==1){
           break;
           }
       }while(RE2_bit);
          if(controlE==1)
            break;
          num2=num2+j;
          WordToStr(num2, txt2);                   // Transform counter value to string
          Lcd_Out(2, 12, txt2);
          delay_ms(500) ;
          num3=num3+k;
         WordToStr(num3, txt2);                   // Transform counter value to string
          Lcd_Out(3, 12, txt2);
          delay_ms(800)  ;
          if(num3>21 || num2==21){
            Lcd_Out(4, 2, "!Perdistee!");            // Write message text on Lcd
            PORTC=0xC8;
            delay_ms(2500)  ;
            break;
          } ;
          if(num2>21 || num3==21){
            Lcd_Out(4, 2, "!Ganastee!");
            RB6_bit =1;
            delay_ms(300)  ;
            RB6_bit =0;
            delay_ms(300)  ;
            RB6_bit =1;
            delay_ms(300)  ;
            RB6_bit =0;
            delay_ms(300)  ;
            RB6_bit =1;
            delay_ms(300)  ;
            RB6_bit =0;
            delay_ms(300)  ;
            RB6_bit =1;
            delay_ms(300)  ;
            RB6_bit =0;
            break;
          } ;
     }while(1);
     if(controlE==1)
            break;
    }while(1);
   }
  } while (1);
  }